import sys
import subprocess
import shlex
import os
import urllib
import tempfile
import zipfile

URL = "http://protobuf.googlecode.com/files/protoc-2.4.1-win32.zip"

def get_protoc():
    response = urllib.urlopen(URL)
    data = response.read()
    if not data:
        raise Exception("Unable to download %s" % URL)

    fd, name = tempfile.mkstemp()

    with os.fdopen(fd, "w") as f:
        f.write(data)
    with zipfile.ZipFile(name) as zf:
        path = zf.extract("protoc.exe", "bin")
    return path

def _main():
    bin_dir = os.path.join(os.getcwd(), "bin")
    if not os.path.exists(os.path.join(bin_dir, "protoc.exe")):
        path = get_protoc()
        print "Protobuf compiler installed to %s" % path

if __name__ == "__main__":
    sys.exit(_main())

